/*
 * alias-private.h
 * Copyright 2000 Jeremy Nelson and others ("EPIC Software Labs")
 *
 * This file is only to be included by alias-commands.c, alias-assign.c,
 * alias-common.c, expr.c, and expr2.c, the five of which comprise the
 * old logical 'assign.c' file.  Inclusion of this file by anyone else
 * shall be punishable by a public flogging. DONT DO IT.  DONT EVEN THINK
 * ABOUT IT.  You have been warned.  Thank you.
 */
#ifndef __alias__private_h__
#define __alias__private_h__

#include "alist.h"

typedef struct ArgListT {
        char *  vars[32];
        char *  defaults[32];
        int     void_flag;
        int     dot_flag;
}	ArgList;

typedef struct  AliasItemStru
{
        char    *name;                  /* name of alias */
        char    *stuff;                 /* what the alias is */
        char    *stub;                  /* the file its stubbed to */
        char    *filename;              /* file it was loaded from */
        int     line;                   /* line it was loaded from */
        int     global;                 /* set if loaded from `global' */
        int     cache_revoked;          /* Cache revocation index */
        ArgList *arglist;               /* List of arguments to alias */
}       Alias;

typedef struct  AliasStru
{
        Alias **        list;
        int             max;
        int             max_alloc;
        alist_func      func;
}       AliasSet;

/*
 * This is the ``stack frame''.  Each frame has a ``name'' which is the
 * name of the ALIAS or ON of the frame, or is NULL if the frame is not
 * an ``enclosing'' frame.  Each frame also has a ``current command'' that 
 * is being executed, which is used to help us when the client crashes.
 * Each stack also contains a list of local variables.
 */
typedef struct RuntimeStackStru
{
	const char *name;	/* Name of the stack */
	char 	*current;	/* Current cmd being executed */
	AliasSet alias;		/* Local variables */
	int	locked;		/* Are we locked in a wait? */
	int	parent;		/* Our parent stack frame */
}	RuntimeStack;

/*
 * This is the master stack frame container.  It's size is saved in
 * ``max_wind'', and the current frame in use is stored in ``wind_index''.
 */
extern 	RuntimeStack *	call_stack;
extern	int 		max_wind;
extern	int 		wind_index;

extern	int		unstub_in_progress;
extern	AliasSet 	cmd_alias;
extern	u_long		alias_total_bytes_allocated;
extern	int		last_function_call_level;

	Alias *	make_new_Alias 		(const char *);
	void	destroy_aliases 	(int);
	void	do_stack_alias 		(int, char *, int);
	void	unload_var_alias 	(const char *);
	char *	after_expando 		(const char *, int, int *);
	char *	get_variable_with_args (const char *, const char *, int *);
	Alias *	find_local_alias 	(const char *, AliasSet **);
	Alias *	find_var_alias 		(const char *, int);
	char **	glob_assign_alias	(char *, int *);
	char **	pmatch_assign_alias	(char *, int *);

	void 	add_cmd_alias 		(char *, ArgList *, char *, int);
	void	add_cmd_stub_alias	(char *, char *, int);
	Alias *	find_cmd_alias 		(char *, int *, int);
	void	delete_cmd_alias 	(char *, int);
	void	unload_cmd_alias 	(const char *);
	char **	glob_cmd_alias		(char *, int *);
	char **	pmatch_cmd_alias	(char *, int *);

	char *	alias_special_char 	(char **, char *, const char *, 
					 char *, int *);
	char *	matheval 		(char *, const char *, int *, int);

#endif
