/* $EPIC:$ */
/*
 * names.h: Header for names.c
 *
 * Copyright 1997 EPIC Software Labs
 * See the COPYRIGHT file, or do a HELP IRCII COPYRIGHT 
 */

#ifndef __names_h__
#define __names_h__

#include "window.h"

typedef const char *	Chname;
typedef const char *	Nickname;
typedef char		Channel_List[MAX_CHANNELS_PER_SERVER][CHANNEL_LEN];
#ifndef Servref_defined
	typedef int	Servref;
#define Servref_defined
#endif
typedef enum    channel_status_u {
        UNKNOWN,                /* No idea what our status is */
        JOIN_SENT,              /* Rejoining, waiting for JOIN to come back */
        SYNCING,                /* JOIN recieved, MODE and WHO pending */
        ACTIVE,                 /* MODE and WHO all done, normal mode */
        PART_SENT,              /* PART sent, waiting for PART to come back */
	KICKED,			/* KICKed from channel, waiting for rejoin */
        DISCONNECTED,           /* Idle channel on disconnected server */
        DECEASED,               /* Dead channel, bury on sight */
}       CStatus;

struct ChannelListStru;		/* XXX Ick, gross, bad. XXX */

#define im_on_channel channel_im_on

	struct ChannelListStru *init_channels		(void);

	/* Channel stuff */
	void	channel_create			(Chname, Servref, Winref, int, Char *);
	/* XXX Should be done through channel_change_state */
	void	channel_remove			(Chname, Servref);
	int	channel_im_on			(Chname, Servref);
	void	channel_mode_update		(Chname, Servref, Char *);
	void	channel_status_change		(Chname, Servref, CStatus);
	void	channel_suspend			(Servref);

	Char *	channel_friendly		(Chname, Servref);
	Char *	channel_key			(Chname, Servref);
	Char *	channel_mode			(Chname, Servref);
	int	channel_private			(Chname, Servref);
	int	channel_nomsgs			(Chname, Servref);
	int	channel_bind			(Chname, Servref, Winref);
	int	channel_unbind			(Chname, Servref, Winref);
	void	channel_list			(void);
	int	channel_im_oper			(Chname, Servref);
	int	channel_im_voice		(Chname, Servref);
	void	channel_switch			(char, char *);
	void	channel_server_change		(Servref, Servref);
	void	channel_server_remove		(Servref);
	void	channel_server_reconnect	(Servref);
	void	channel_server_destroy		(Servref);
	Char *	channel_what			(Nickname);
	int	channel_getlist		(Servref, Nickname, Channel_List);
	Winref	channel_window			(Chname, Servref);
	void	channel_window_set		(Winref, Chname, int);
	char *	channel_list_get		(Servref);
	Char *	channel_window_current		(Winref, Servref);
	Char *	channel_type			(Chname, Servref);
	int	auto_rejoin_callback		(void *);
	int	channel_syncing			(Chname, Servref);
	void	channel_is_current		(Winref, Chname, Servref);
	void	channel_server_disconnect	(Servref);
	void	channel_part_all		(Winref);

	/* Nickname stuff */
	void	channel_nick_add		(Chname, Servref, Nickname, 
						 int, int, int, int);
	void	channel_userhost_add		(Chname, Servref, Nickname, 
						 Char *);
	void	channel_nick_remove		(Chname, Servref, Nickname);
	void	channel_nick_rename		(Servref, Nickname, Nickname);

	int	channel_nick_onchannel		(Chname, Servref, Nickname);
	int	channel_nick_chanop		(Chname, Servref, Nickname);
	int	channel_nick_voice		(Chname, Servref, Nickname);
	int	channel_nick_number		(Chname, Servref);
	char *	channel_nick_list		(Chname, Servref);
	char *	channel_nick_allchops		(Chname, Servref);
	char *	channel_nick_allnochops		(Chname, Servref);
	Char *	fetch_userhost			(Servref, Nickname);
	char *	scan_channel			(Chname, Servref);
	BUILT_IN_COMMAND(partcmd);
	int	is_current_channel		(Chname, Servref);
	void	window_leaving_server		(Winref, Servref);
	void	channel_check_servers		(void);

/* Private names.c stuff */

/*
 * The variable "mode_str" must correspond in order to the modes defined
 * here, or all heck will break loose.  You have been warned.
 */
/* static	char	mode_str[] = "aciklmnprstzR"; */

#define MODE_ANONYMOUS	1 << 0
#define MODE_C		1 << 1
#define MODE_INVITE	1 << 2
#define MODE_KEY    	1 << 3
#define MODE_LIMIT	1 << 4
#define MODE_MODERATED	1 << 5
#define MODE_MSGS	1 << 6
#define MODE_PRIVATE	1 << 7
#define MODE_REGISTERED 1 << 8
#define MODE_SECRET	1 << 9
#define MODE_TOPIC	1 << 10
#define MODE_Z		1 << 11
#define MODE_RESTRICTED 1 << 12

#endif /* _NAMES_H_ */
