/* $EPIC:$ */
#ifndef __symtab_h__
#define __symtab_h__

typedef	struct 
{
	char *		name;
	void *		command;
	void *		alias;
} da_item;

typedef	struct 
{
	char *		name;
	void *		assign;
	void *		builtin;
	void *		set;
	void *		environ;
} vt_item;

	int		add_builtin_command_entry (const char *, void *);
	int		add_alias_command_entry (const char *, void *);
	da_item *	get_cmd_item (const char *, int *, char **);
	int		get_cmd_location (const char *, int *);
	void *		remove_builtin_command_entry (const char *);
	void *		remove_alias_command_entry (const char *);
	void *		foreach_alias_item (int *);

	int		add_builtin_func_entry (const char *, void *);
	int		add_alias_func_entry (const char *, void *);
	da_item *	get_func_item (const char *, int *, char **);
	void *		remove_builtin_func_entry (const char *);
	void *		remove_alias_func_entry (const char *);

	int		add_assign_var_entry (const char *, void *);
	int		add_builtin_var_entry (const char *, void *);
	int		add_set_var_entry (const char *, void *);
	int		add_environ_var_entry (const char *, void *);
	vt_item	*	get_var_item (const char *);
	int		get_var_location (const char *, int *);
	void *		remove_assign_var_entry (const char *);
	void *		remove_builtin_var_entry (const char *);
	void *		remove_set_var_entry (const char *);
	void *		remove_environ_var_entry (const char *);
	void *		foreach_assign_item (int *);

	void		command_table_stats (void);
	void		set_up_symbols (void);

#endif
